﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;

namespace ut
{
    class Auto
    {
        public int Ora { get; set; }
        public int Perc { get; set; }
        public int Mp { get; set; }
        public int DT { get; set; }
        public int KiT { get; set; }
        public int Idő()
        {
            return 3600 * Ora + 60 * Perc + Mp;
        }
        public double V()
        {
            return (double)1000 / DT;
        }
        public char Irány { get; set; }
        public Auto(int O, int P, int M, int D, char I)
        {
            Ora = O; Perc = P; Mp = M; DT = D; Irány = I;
        }
    }
    class Program
    {
        static void Main(string[] args)
        {
            #region 1. feladat - adatbeolvasás
            StreamReader be = new StreamReader("forgalom.txt");
            int db = Convert.ToInt32(be.ReadLine());
            string sor;
            string[] adatok = new string[5];
            LinkedList<Auto> forg = new LinkedList<Auto>();
            for (int i = 0; i < db; i++)
            {
                sor = be.ReadLine();
                adatok = sor.Split(' ');
                forg.AddLast(new Auto(Convert.ToInt32(adatok[0]), Convert.ToInt32(adatok[1]), Convert.ToInt32(adatok[2]), Convert.ToInt32(adatok[3]), Convert.ToChar(adatok[4])));
            }
            be.Close();
            #endregion
            #region 2. feladat - merre
            Console.Write("2. feladat: Adja meg a jármű sorszámát! ");
            int n = Convert.ToInt32(Console.ReadLine());
            Console.WriteLine("\tA {0}. autó {1} felé haladt.", n, forg.ElementAt(n).Irány == 'F' ? "Alsó város" : "Felső város");
            #endregion
            LinkedList<Auto> gyűjtő;
            #region 3. feladat - utolso két autó
            Console.WriteLine("3. feladat");
            
            gyűjtő = new LinkedList<Auto>(forg.Where(a => a.Irány =='A'));
            #region más megoldások
            //ez is jó LINQ:
            //gyűjtő = new LinkedList<Auto>(from a in forg where a.Irány == 'A' select a);
            //ez is jó, csak hosszabb
            //foreach (Auto a in forg)
            //{
            //    if (a.Irány == 'A')
            //    {
            //        gyűjtő.AddLast(a);
            //    }
            //}
            #endregion
            Console.WriteLine("\tAz utolsó két autó {0} mp különbséggel érte el az útszakasz kezdetét.", gyűjtő.Last().Idő() - gyűjtő.Last.Previous.Value.Idő());
            #endregion
            #region 4. feladat - óránként
            Console.WriteLine("4. feladat:");
            int[] A = new int[24];
            int[] F = new int[24];
            for (int i = 0; i < 24; i++)
            {
                A[i] = F[i] = 0;
            }
            foreach (Auto a in forg)
            {
                if (a.Irány == 'A')
                { A[a.Ora]++; }
                else
                {
                    F[a.Ora]++;
                }
            }
            for (int i = 0; i < 24; i++)
            {
                if (A[i] + F[i] != 0)
                {
                    Console.WriteLine("\t{0:D2}-{1:D2} között\t{2} jármű Alsó,\t{3} jármű Felső városból jött.", i, i + 1, A[i], F[i]);
                }
            }
            #endregion
            #region 5. feladat - 10 leggyorsabb
            Console.WriteLine("5. feladat");
            //jó, csak hosszú:
            //gyűjtő = new LinkedList<Auto>(forg.OrderBy(delegate(Auto a) { return a.DT; }).Take<Auto>(10));
            
            gyűjtő = new LinkedList<Auto>(forg.OrderBy(a =>a.DT).Take<Auto>(10));

            //ez is jó, csak hosszú és nem szép.
            //gyűjtő.Clear();
            //for (int i = 0; i < 10; i++)
            //{gyűjtő.AddLast(forg.OrderBy(a => a.DT).ElementAt<Auto>(i));}

            foreach (Auto a in gyűjtő)
            {
                Console.WriteLine("\t{0:D2}:{1:D2}:{2:D2}\t{3}\t{4:F1}", a.Ora, a.Perc, a.Mp, a.Irány == 'A' ? "Alsó" : "Felső", a.V());
            }
            #endregion
            #region 6. feladat - kilépések
            Console.WriteLine("6. feladat");
            StreamWriter ki = new StreamWriter("also.txt");
            gyűjtő.Clear();
            foreach (Auto a in forg)
            {
                if (a.Irány == 'F')
                {
                    gyűjtő.AddLast(a);
                    if (gyűjtő.Count == 1)
                    {
                        gyűjtő.Last().KiT = gyűjtő.Last().Idő() + gyűjtő.Last().DT;
                    }
                    else
                    {
                        gyűjtő.Last().KiT = Math.Max(gyűjtő.Last.Previous.Value.KiT, gyűjtő.Last().Idő() + gyűjtő.Last().DT);
                    }
                    ki.WriteLine("{0:D2} {1:D2} {2:D2}", gyűjtő.Last().KiT / 3600, (gyűjtő.Last().KiT % 3600) / 60, gyűjtő.Last().KiT % 60);
                }
            }
            ki.Close();
            Console.WriteLine("A kiírás befejeződött");
            #endregion
            Console.ReadLine();
        }
    }
}
